
import time
import calendar

from events import events

import Calendar


def get_time_list(space=30):
	n = 1440 / space
	l = []
	a = -3600
	for x in range(n):
		l.append(time.ctime(a).split()[3][0:5])
		a += space*60
	return l
	
def is_time(t):
	try:
		nt = time.strptime(t, "%H:%M")
		return time.strftime("%H:%M", nt)
	except ValueError:
		return None

def dbdate_from_localdate(date):
	t = time.strptime(date, "%x")
	return time.strftime("%Y-%m-%d")

def localdate_from_dbdate(date):
	t = time.strptime(date, "%Y-%m-%d")
	return time.strftime("%x", t)

class cal:
	def __init__(self, first_weekday):
		global _; _ = Calendar._
		
		calendar.setfirstweekday(first_weekday)
		
		self.days = [_("Su"), _("Mo"), _("Tu"), _("We"), _("Th"), _("Fr"), _("Sa")]
		self.months = [_("January"), _("February"), _("March"), _("April"), 
		               _("May"), _("June"), _("July"), _("August"), _("September"),
		               _("October"), _("November"), _("December")]

	def next_dayname(self, last):
		while last > 6:
			last = last - 7
		return self.days[last]

	def get_page(self, stamp = time.localtime()):
		m = int(time.strftime("%m", stamp))
		y = int(time.strftime("%Y", stamp))
		return m, y
		
	def get_fweek_mdays(self, page):
		m, y = page
		w, d = calendar.monthrange(y, m)
		return w, d
	
	def get_today(self, page = (0, 0)):
		a, b, c, d, e, f, g, h, i = time.localtime()
		if a == page[1] and b == page[0]:
			ret = int(time.strftime("%d"))
		else:
			ret = 0
		return ret
	
	def get_monthname(self, month):
		return self.months[month-1]
	
	def page_increase(self, page):
		m, y = page
		if m == 12:
			m = 1
			y += 1
		else:
			m += 1
		return m, y
	
	def page_decrease(self, page):
		m, y = page
		if m == 1:
			m = 12
			y -= 1
		else:
			m -= 1
		return m, y


	def get_days_with_tasks(self, page):
		m, y = page
		evs = events()
		days = evs.get_event_days_from_month(m, y)
		return days
