
import time
import calendar
import string

class event:
	def __init__(self):
		self.ID = 0                              # setting an initial ID
		self.date = time.strftime("%Y-%m-%d")    # the actual date
		self.full_day = 0                        # 1 for full day events
		self.start = time.strftime("%H:%M")      # a start time
		self.end = time.strftime("%H:%M")        # a end time
		self.summary = ""                        # a summary
		self.note = ""                           # a note
		self.offset = 0                          # the offset in seconds of a reminder 
		                                         # to the starttime


		#self.recurrence_times = 0           # settings for recurrence
		self.recurrence_until = self.date  # end date for recurrence
		
		#self.recurrence_distance = 0        # distance in recurrence in days
		self.recurrence_weekdays = []       # days of the week (sun 0)
		
		
		self.recurrence_exceptions = []       # list of dates
		

		self.has_date = 1
		self.has_summary = 1
		self.has_note = 1
		self.has_offset = 0
		self.has_reminder = 0
		self.has_recurrence = 0

	
	def set_type(self, evtype):
		self.evtype = evtype
	
	def get_type(self):
		if not hasattr(self, "evtype"):
			self.evtype = 0
		return self.evtype

	# check if the event appears on the date:
	def event_on_date(self, date):
		testdate = time.strptime(date, "%Y-%m-%d")
		date = time.strptime(self.date, "%Y-%m-%d")
		if self.has_recurrence != 1 and date == testdate:
			return 1
		if self.has_recurrence == 1:
			until = time.strptime(self.recurrence_until, "%Y-%m-%d")
			if time.mktime(testdate) < time.mktime(date):
				return 0
			if time.mktime(testdate) > time.mktime(until):
				return 0

			testweekday = int(time.strftime("%w", testdate))
			if self.recurrence_weekdays.count(testweekday) > 0:
				for x in self.recurrence_exceptions:
					t = string.split(x, ',')
					if len(t) == 1:
						excdate = time.strptime(t[0], "%Y-%m-%d")
						if excdate == testdate:
							return 0
					elif len(t) == 2:
						excdate1 = time.mktime(time.strptime(t[0], "%Y-%m-%d"))
						excdate2 = time.mktime(time.strptime(t[1], "%Y-%m-%d"))
						exctest = time.mktime(testdate)
						if exctest >= excdate1 and exctest <= excdate2:
							return 0
				return 1
							
		return 0

	def event_in_month(self, m, y):
		date = time.strptime(self.date, "%Y-%m-%d")
		tm = int(time.strftime("%m", date))
		ty = int(time.strftime("%Y", date))

		if self.has_recurrence != 1:
			if tm == m and ty == y:
				return [int(time.strftime("%d", date))]
			else:
				return 0
		if self.has_recurrence == 1:
			recurrence_until = time.strptime(self.recurrence_until, "%Y-%m-%d")
			tleft = time.mktime(time.strptime(time.strftime("%Y-%m", date), "%Y-%m"))
			tright = time.mktime(time.strptime(time.strftime("%Y-%m", recurrence_until), "%Y-%m"))
			left = time.mktime(time.strptime((str(y) + "-" + str(m)), "%Y-%m"))
			
			if m == 12:
				rm = 1
				ry = y + 1
			else:
				rm = m + 1
				ry = y
			right = time.mktime(time.strptime((str(ry) + "-" + str(rm)), "%Y-%m"))
			
			if tleft > right or tright < left:
				return 0
			
			days = []
			w, d = calendar.monthrange(y, m)
			for x in range(d-1):
				date1 = time.strftime("%Y-%m-%d", (y, m, x+1, 0, 0, 0, 0, 0, 0))
				if self.event_on_date(date1) == 1:
					days.append(x+1)
			if len(days) > 0:
				return days
				
		return 0
