import gtk
import gobject

import string

from helpers import CalendarSelection
from cal import cal, localdate_from_dbdate

import Calendar

class recurrence_editor(gtk.Table):
	def __init__(self, e, firstweekday):
		global _; _ = Calendar._
		
		self.e = e
		self.firstweekday = firstweekday
		
		gtk.Table.__init__(self)
		
		self.set_border_width(6)
		self.set_row_spacings(5)
		self.set_col_spacings(5)


		# recurrency or not?
		use_rec_button = gtk.CheckButton(_("Use Recurrence"))
		#use_rec_label = gtk.Label("<b>" + _("Use Recurrence") + "</b>")
		#use_rec_button = gtk.CheckButton("<b>" + _("Recurrence") + "</b>")
		#use_rec_label.set_use_markup(gtk.TRUE)
		#use_rec_label.show()
		use_rec_button.show()

		if self.e.has_recurrence == 1:
			use_rec_button.set_active(gtk.TRUE)


		use_rec_button.connect("clicked", self.set_use_recurrence)

		use_rec_alignment = gtk.Alignment(1.0, 1.0, 1.0, 1.0)
		use_rec_alignment.add(use_rec_button)
		use_rec_alignment.show()


		# until date:
		self.until_label = gtk.Label(_("Until"))
		self.until_label.show()
		
		self.until_date = CalendarSelection(self.e.date, self.firstweekday)
		self.until_date.set_date(self.e.recurrence_until)
		self.until_date.show()
		
		self.until_date.entry.connect("activate", self.set_until_date)

		# rules:
		self.check_weekdays = gtk.HBox()
		
		self.check_weekdays_label = gtk.Label(_("Every"))
		self.check_weekdays_label.show()
			
		c = cal(self.firstweekday)
		i = 0
		for x in c.days:
			b = gtk.CheckButton(x)
			
			if self.e.recurrence_weekdays.count(i) > 0:
				b.set_active(gtk.TRUE)
			
			self.check_weekdays.pack_start(b, gtk.FALSE, gtk.FALSE, 2)
			b.connect("clicked", self.set_recurrency_weekday, i)
			i += 1
		
		self.check_weekdays.show_all()


		# setting exceptions
		
		self.exception_frame = gtk.Frame(_("Exceptions"))
		exception_hbox = gtk.HBox(gtk.FALSE)
		exception_hbox.set_border_width(7)
		self.exception_frame.add(exception_hbox)
		
		exception_sw = gtk.ScrolledWindow()
		exception_sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		self.exception_model = gtk.TreeStore(gobject.TYPE_STRING, gobject.TYPE_STRING)
		treeview = gtk.TreeView(self.exception_model)
		treeview.set_size_request(200, 100)
		exception_sw.add(treeview)
		
		exception_hbox.pack_start(exception_sw, gtk.FALSE, gtk.FALSE, 5)
				
		renderer = gtk.CellRendererText()
		column = gtk.TreeViewColumn(_("Exceptions"), renderer, text=0)
		treeview.append_column(column)
		
		#renderer = gtk.CellRendererText()
		#column = gtk.TreeViewColumn(_("Summary"), renderer, text=1)
		#treeview.append_column(column)
		
		selection = treeview.get_selection()
		#selection.connect("changed", self.change_current_e, None)

		
		vbox = gtk.VBox()

		from_label = gtk.Label(_("From"))
		from_cal = CalendarSelection(self.e.date, self.firstweekday)
		
		to_label = gtk.Label(_("To"))
		to_cal = CalendarSelection(self.e.date, self.firstweekday)


		minitable = gtk.Table(2, 2)
		minitable.attach(from_label, 0, 1, 0, 1, gtk.FILL, gtk.FILL, 5)
		minitable.attach(from_cal,   1, 2, 0, 1, gtk.FILL, gtk.FILL, 5)
		minitable.attach(to_label,   0, 1, 1, 2, gtk.FILL, gtk.FILL, 5)
		minitable.attach(to_cal,     1, 2, 1, 2, gtk.FILL, gtk.FILL, 5)
		
		vbox.pack_start(minitable, gtk.FALSE, gtk.FALSE, 5)
		
		from_cal.entry.connect("activate", self.from_cal_changed, from_cal, to_cal)
		
		
		add = gtk.Button("Add", gtk.STOCK_ADD)
		delete = gtk.Button("Delete", gtk.STOCK_DELETE)
		vbox.pack_start(add, gtk.FALSE, gtk.FALSE, 5)
		vbox.pack_start(delete, gtk.FALSE, gtk.FALSE, 5)
		exception_hbox.pack_start(vbox, gtk.FALSE, gtk.FALSE, 5)

		add.connect("clicked", self.add_exception, from_cal, to_cal)
		delete.connect("clicked", self.delete_exception, selection)

		self.exception_frame.show_all()

		# Filling the recurrence table:
		self.resize(4, 2)   # row, cols
		self.attach(use_rec_alignment,          0, 2, 0, 1, gtk.FILL, gtk.FILL)
		self.attach(self.until_label,           0, 1, 1, 2, gtk.FILL, gtk.FILL)
		self.attach(self.until_date,            1, 2, 1, 2, gtk.FILL, gtk.FILL)
		self.attach(self.check_weekdays_label,  0, 1, 2, 3, gtk.FILL, gtk.FILL)
		self.attach(self.check_weekdays,        1, 2, 2, 3, gtk.FILL, gtk.FILL)
		self.attach(self.exception_frame,       0, 2, 3, 4, gtk.FILL, gtk.FILL)


		self.run_sensitiveness()
		self.fill_model()

	def set_use_recurrence(self, widget, data=None):
		self.e.has_recurrence = widget.get_active()
		self.run_sensitiveness()

	def run_sensitiveness(self):
		if self.e.has_recurrence == 1:
			self.until_label.set_sensitive(gtk.TRUE)
			self.until_date.set_sensitive(gtk.TRUE)
			self.check_weekdays_label.set_sensitive(gtk.TRUE)
			self.check_weekdays.set_sensitive(gtk.TRUE)
			self.exception_frame.set_sensitive(gtk.TRUE)
		else:
			self.until_label.set_sensitive(gtk.FALSE)
			self.until_date.set_sensitive(gtk.FALSE)
			self.check_weekdays_label.set_sensitive(gtk.FALSE)
			self.check_weekdays.set_sensitive(gtk.FALSE)
			self.exception_frame.set_sensitive(gtk.FALSE)

	def set_until_date(self, entry, data=None):
		self.e.recurrence_until = self.until_date.get_date()
		
	def set_recurrency_weekday(self, widget, day):
		s = widget.get_active()
		if s == 1:
			self.e.recurrence_weekdays.append(day)
		else:
			self.e.recurrence_weekdays.remove(day)

	def from_cal_changed(self, entry, from_cal, to_cal):
		to_cal.set_date(from_cal.get_date())

	def fill_model(self):
		self.exception_model.clear()
		
		for x in self.e.recurrence_exceptions:
			t = string.split(x, ',')
			iter = self.exception_model.append(None, None)
			self.exception_model.set_value(iter, 1, x)
						
			if len(t) == 1:
				self.exception_model.set_value(iter, 0, localdate_from_dbdate(t[0]))
			elif len(t) == 2:
				self.exception_model.set_value(iter, 0, localdate_from_dbdate(t[0]) + " - " +  localdate_from_dbdate(t[1]))
	
	def add_exception(self, button, from_cal, to_cal):
		f = from_cal.get_date()
		t = to_cal.get_date()
		if f == t:
			self.e.recurrence_exceptions.append(f)
		else:
			self.e.recurrence_exceptions.append(f + "," + t)
		
		self.fill_model()
	
	def delete_exception(self, button, selection):
		model, iter = selection.get_selected()
		self.e.recurrence_exceptions.remove(model.get_value(iter, 1))
		
		self.fill_model()
