from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import time
import os
import commands

class LTVUptime(Sensor):

	def __init__(self, interval = "50", format = "%dd %hh %mm", u = "1", t = "0", n = "0", os="0", k = "0", r = "0", p="0" ):
		global _; _ = i18n.Translator("uptime-sensor")
		
		if n == "1" or os == "1" or "k" == "1" or r == "1" or p == "1" :
			c = "1"
		else:
			c = "0"
		self.__enable = [u,t,c,[n,os,k,r,p]]
		self.__uptime = "0d 0h 0m"
		Sensor.__init__(self)

		self._set_config_type("thermal", TYPE_STRING, t)
		self._set_config_type("update", TYPE_INT, int(interval))
		self._set_config_type("format", TYPE_STRING, format)
		self._set_config_type("host", TYPE_STRING, commands.getoutput("uname -n"))
		self._set_config_type("os", TYPE_STRING, commands.getoutput("uname -o"))
		self._set_config_type("kernel", TYPE_STRING, commands.getoutput("uname -s"))
		self._set_config_type("version", TYPE_STRING, commands.getoutput("uname -r"))
		self._set_config_type("processor", TYPE_STRING, commands.getoutput("uname -p"))
		self._add_thread(self.__command_thread)

	def get_configurator(self):
		configurator = self._new_configurator()
		u = self.__enable[ 0 ]
		t = self.__enable[ 1 ]
		c = self.__enable[ 2 ]
		if u == "0" and t == "0" and c == "0":
			return configuratior
		configurator.set_name(_("System info"))
		
		if u != "0" or t != "0" :
			configurator.add_title(_("Display"))
			configurator.add_spin(_("Update every (ds):"), "update", _("Updates the display every x deciseconds"), 1, 600)
		
		if u != "0" :
			configurator.add_title(_("Uptime"))
			configurator.add_entry(_("Format:"), "format", _("Days:\t%d\nHours:\t%h\nMinutes:\t%m\nSeconds:\t%s"))

		if t != "0" :
			configurator.add_title(_("Termal info"))
			configurator.add_option(_("Units:"), "thermal", _("Units to display temperature in."),[["Celcius","c"],["Fahrenheit","f"],["Kelvin","k"]])

		if c == "1" :
			configurator.add_title(_("General"))
			if self.__enable[ 3 ][ 0 ] != "0" :
				configurator.add_entry(_("Host name:"), "host", _("Your name on a network."))
			if self.__enable[ 3 ][ 1 ] != "0" :
				configurator.add_entry(_("OS name:"), "os", _("Your operating system."))
			if self.__enable[ 3 ][ 2 ] != "0" :
				configurator.add_entry(_("Kernel name:"), "kernel", _("Your system's kernel."))
			if self.__enable[ 3 ][ 3 ] != "0" :
				configurator.add_entry(_("Kernel version:"), "version", _("Your system's kernel's version."))
			if self.__enable[ 3 ][ 4 ] != "0" :
				configurator.add_entry(_("Processor name:"), "processor", _("Your system's processor."))
		return configurator
	
	def __command_thread(self):
		while (1):
			if (self._is_stopped()): break
			
			data = commands.getoutput("cat /proc/uptime")
			uptime = float( data.split()[0] )
			days = int( uptime / 60 / 60 / 24 )
			uptime = uptime - days * 60 * 60 * 24
			hours = int( uptime / 60 / 60 )
			uptime = uptime - hours * 60 * 60
			minutes = int( uptime / 60 )
			uptime = uptime - minutes * 60
			seconds = int( uptime )
			self.__uptime = self._get_config("format").replace("%d",str(days)).replace("%h",str(hours)).replace("%m",str(minutes)).replace("%s",str(seconds))
			
			
			data = self._new_output()
			data.set("host",self._get_config("host"))
			data.set("os",self._get_config("os"))
			data.set("kernel",self._get_config("kernel"))
			data.set("version",self._get_config("version"))
			data.set("processor",self._get_config("processor"))
			data.set("uptime",self.__uptime)
			
			t = ""
			if self.__enable[ 1 ] != "0" :
				t = commands.getoutput("acpi -B -t -" + self._get_config("thermal"))
				if t[5:][:7] == "Thermal" :
					t = str( int( float( t.split()[ 3 ] ) ) )
					if self._get_config("thermal") == "f" :
						t = t + "&#176;F"
					elif self._get_config("thermal") == "k" :
						t = t + " K"
					else:
						t = t + "&#176;C"
				else:
					t = ""
			data.set("temperature", t)
			self._send_output(data)
			time.sleep(self._get_config("update")*0.1)
def new_sensor(args): return apply(LTVUptime, args)
