from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import commands
import urllib
import os
import rdfxml
import re

class Sink(object): 

	def __init__(self): 

		self.result = []

	def triple(self, s, p, o): 

		if re.search("title", p):
			o = o[1:-1] + "\n"
			self.result.append(o)

class RssSensor(Sensor):

	def __init__(self, *args):

	        global _; _ = i18n.Translator("rss-desklet")
		Sensor.__init__(self)

		# set a default for the rss url
		self._set_config_type("url", TYPE_STRING, "http://dweazle.themirror.nl/rss")

		self._add_timer(0, self.__get_feed)

	def __get_feed(self):
		
		url = self._get_config("url")
		sink = Sink()
		rssdata = rdfxml.parseURI(url, sink=sink).result
		regex = re.compile('"')
		data = regex.sub('\n', ("".join(rssdata)))

		output = self._new_output()
		output.set("rss", data)

		self._send_output(output)
		self._add_timer(300000, self.__get_feed)

	def get_configurator(self):

		configurator = self._new_configurator()
		configurator.set_name(_("Rss"))
		configurator.add_title(_("Rss settings"))
		configurator.add_entry(_("URL",), "url", _("The url of the rss feed"))

		return configurator

def new_sensor(args): return apply(RssSensor, args)

