from DesktopReader import DesktopReader
from IconTheme import IconTheme

import os
import commands


class Icon:

    # the pixmap directory of GNOME
    __GNOME_PIXMAP_DIR = \
      os.path.join(
        commands.getoutput("dirname `which gnome-desktop-item-edit`"),
        "..", "share", "pixmaps")

    # the unknown icon
    __UNKNOWN_ICON = "gnome-unknown.png"


    def __init__(self, desktopfile, theme = ""):

        self.__icon_theme = IconTheme(theme)
        self.__zoom_level = 1.0
        self.__command = ""
        self.__pixmap = ""

        self.__load_icon(desktopfile)



    #
    # Loads the given icon.
    #
    def __load_icon(self, desktopfile):
        
        reader = DesktopReader(desktopfile)
        iconname = reader.get_icon()
        self.__pixmap = self.__icon_theme.lookup_icon(iconname)
        if (not self.__pixmap):
            self.__pixmap = self.__icon_theme.lookup_icon(self.__UNKNOWN_ICON)

        try:
            self.__command = reader.get_exec()
        except:
            self.__command = ""



    def get_pixmap(self): return self.__pixmap

    def set_zoom(self, zoom): self.__zoom_level = zoom
    def get_zoom(self): return self.__zoom_level

    def get_command(self): return self.__command
